import gconf
import pickle
import string
import sys
import threading
import os
import pynotify

class GconfSerializer():
	
	def __init__(self):
		
		self.client=gconf.client_get_default()
		self.changeset=gconf.ChangeSet()
		self.dic={}
		self.tmp=""
		self.entry=""


	
	def read_values(self,path):
		
		result=self.client.all_dirs(path)
		tmp=""
		for dir in result:
			
			if dir.rfind("schemas")==-1:
				self.read_values(dir)
			
				

	
			entries=self.client.all_entries(dir)
			for entry in entries:
				found=False
				
				if entry.value!=None:
					if entry.value.type == gconf.VALUE_BOOL:
						tmp=entry.value.get_bool()
						found=True
					elif entry.value.type == gconf.VALUE_STRING:
						tmp=entry.value.get_string()
						found=True
					elif entry.value.type == gconf.VALUE_INT:
						tmp=entry.value.get_int()
						found=True

					elif entry.value.type==gconf.VALUE_FLOAT:
						tmp=entry.value.get_float()
						found=True
					
					elif entry.value.type==gconf.VALUE_LIST:
						list_=entry.value.get_list()
						tmp=[]
						tipo=entry.value.get_list_type()
						if tipo == gconf.VALUE_STRING:
							tmp.append('str')
						elif tipo == gconf.VALUE_INT:
							tmp.append('int')
						elif tipo== gconf.VALUE_BOOL:
							tmp.append('bool')
							
						for item in list_:
							if item.type==gconf.VALUE_INT:
								tmp.append(item.get_int())
							if item.type==gconf.VALUE_STRING:
								tmp.append(item.get_string())
							if item.type==gconf.VALUE_BOOL:
								tmp.append(item.get_bool())
						
						found=True

					'''					
					elif entry.value.type==gconf.VALUE_PAIR:
						tmp=entry.value.get_pair()

						found=True
					'''	
					if found:	
						self.dic[entry.key]=tmp
				
		
	#def read_values

	def clear_unmodified_values(self,path):

		list=self.dic.items()
		dic_tmp={}

		
		
		result=self.client.all_dirs(path)
		
		for dir in result:
			self.clear_unmodified_values(dir)
		
		
		f=open(os.path.expanduser("~/diff.gconf"),"a")

		for dir in result:
			entries=self.client.all_entries(dir)
			
			for entry in entries:
				if entry.value!=None:
					if entry.value.type == gconf.VALUE_BOOL:
						if entry.key in self.dic:
							if entry.value.get_bool() == self.dic[entry.key]:
								#print("\n")
								#print(entry.key)
								#print("\n\t")
								#if entry.value:
								#	print("True")
								#else:
								#	print("False")
								
								del self.dic[entry.key]
							
					if entry.value.type == gconf.VALUE_INT:
						if entry.key in self.dic:
							if entry.value.get_int() == self.dic[entry.key]:
								#print("\n")
								#print(entry.key)
								#print("\n\t")
								#print("%d"%entry.value.get_int())
								del self.dic[entry.key]
					
					if entry.value.type == gconf.VALUE_FLOAT:
						if entry.key in self.dic:
							if entry.value.get_float() == self.dic[entry.key]:

								#print("\n")
								#print(entry.key)
								#print("\n\t")
								#print("%s"%entry.value.get_float())
								del self.dic[entry.key]

					if entry.value.type== gconf.VALUE_PAIR:
						if entry.key in self.dic:
							if entry.value.get_pair() == self.dic[entry.key]:
								#print("\n")
								#print(entry.key)
								#print("\n\t")
								#print(entry.value.get_pair())

								del self.dic[entry.key]
					if entry.value.type==gconf.VALUE_STRING:
						if entry.key in self.dic:
							if entry.value.get_string() == self.dic[entry.key]:
								#print("\n")
								#print(entry.key)
								#print("\n\t")
								#print(entry.value.get_string())
								del self.dic[entry.key]

					'''		
					if entry.value.type == gconf.VALUE_LIST:
						
						if entry.key in self.dic:
							list_=entry.value.get_list()
							diff=False
							counter=1
							for item in list_:
								if item.type == gconf.VALUE_BOOL:
									if item.get_bool() != self.dic[entry.key][counter]:
										diff=True
								if item.type == gconf.VALUE_INT:
									if item.get_int() != self.dic[entry.key][counter]:
										diff=True
								if item.type == gconf.VALUE_STRING:
									if item.get_string() != self.dic[entry.key][counter]:
										diff=True
								counter+=1
	
						else:
							diff=True

						if not diff:
							del self.dic[entry.key]
						
						#pass # should i do this?
					'''
							
								
							

		#f.close()


							
					
				
			
			
			
			


	#def clear_unmodified_values
	
	
	def write_values(self):
		
		list=self.dic.items()

			
		
		for item in list:
			
			if type(item[1]).__name__=="str":
				#self.changeset.set_string(item[0],item[1])
				self.client.set_string(item[0],item[1])
			elif type(item[1]).__name__=="int":
				#self.changeset.set_int(item[0],item[1])
				self.client.set_int(item[0],item[1])
			elif type(item[1]).__name__=="bool":
				#self.changeset.set_bool(item[0],item[1])
				self.client.set_bool(item[0],item[1])
			elif type(item[1]).__name__=="float":
				#self.changeset.set_float(item[0],item[1])
				self.client.set_float(item[0],item[1])
			
			elif type(item[1]).__name__=="list":
				tmp2=[]

				if item[1][0]=='str':
					type_=gconf.VALUE_STRING
				if item[1][0]=='int':
					type_=gconf.VALUE_INT
				if item[1][0]=='bool':
					type_=gconf.VALUE_BOOL
				
				for element in item[1][1:]:
					
					if type(element).__name__=="str":
						value=gconf.Value(gconf.VALUE_STRING)
						value.set_string(element)
						#tmp2.append(value)
						tmp2.append(element)
						#print value.get_string()
							
							
					if type(element).__name__=="int":
						value=gconf.Value(gconf.VALUE_INT)
						value.set_int(element)
						#tmp2.append(value)
						tmp2.append(element)
						#print value.get_int()
							
					if type(element).__name__=="bool":
						value=gconf.Value(gconf.VALUE_BOOL)
						value.set_bool(element)
						#tmp2.append(value)
						tmp2.append(element)
						#print value.get_bool()

				#self.changeset.set_list(item[0],type_,tmp2)
				
				
				self.client.set_list(item[0],type_,tmp2)
				
				
			elif type(item[1]).__name__=="pair":
				msg="uh oh it's a pair"
			
			

		#self.client.commit_change_set(self.changeset, True)
		
		
	#def write_values
	
	
	def print_keys(self):
		
		items=self.dic.items()
		
		for item in items:
			print item[0]
		
	#def print_keys
	
	def print_values(self):
		
		items=self.dic.items()
		
		for item in items:
			#if type(item[1]).__name__=="list":
			#	print "type: %s == %s"%(type(item[1]).__name__,item[1])
			print "type: %s == %s"%(type(item[1]).__name__,item[1])
			
			
	#def print_values
	
	def write_file(self,path):
		f=open(path,'wb')
		pickle.dump(self.dic,f,-1)
		f.close()
		
	#def write_file
	
	def load_file(self,path):
		
		f=open(path,'rb')
		self.dic=pickle.load(f)
		f.close()
		
	#def load_file


	
#class PickleTest


if __name__=="__main__":
	
	pt=GconfSerializer()

	#pt.read_values("/")
	#pt.clear_unmodified_values("/")
	
	stop=False

	if os.path.exists(os.path.expanduser("~/UserFiles/.llx-gnome-profile-manager/.stop")):
		stop=True

	if os.getuid() < 5000:
		sys.exit(0)


	if not stop:
		for i in range(1,len(sys.argv)):
		
			if sys.argv[i]=="--save":
				
				if i+1 <len(sys.argv):
					pynotify.init("Session Notify")
					n = pynotify.Notification( "Copiando sus archivos de perfil" , "No cancele la operacion", "user-home" )
					#n.set_category("device")
					n.show()
					pt.read_values("/apps")
					pt.read_values("/desktop")
					pt.read_values("/system")
					#pt.client.suggest_sync()

					pt.write_file(sys.argv[i+1])
					n.close()
					print("* Save complete")

				else:
					print "USAGE --save filename"
				break	
			elif sys.argv[i]=="--load":
		
				if i+1 < len(sys.argv):

					pt.load_file(sys.argv[i+1])
					pt.clear_unmodified_values("/")
					pynotify.init("Session Notify")
					n = pynotify.Notification( "Cargando perfil" , "Espere", "user-home")
					n.set_urgency(pynotify.URGENCY_CRITICAL)
					#n.set_category("device")
					n.show()
					pt.write_values()
					#pt.client.suggest_sync()
					n.close()
				
				else:
					print "USAGE --load filename"
				break

			elif sys.argv[i]=="--load-test":
				if i+1 < len(sys.argv):

					pt.load_file(sys.argv[i+1])
					print len(pt.dic)
					pt.clear_unmodified_values("/")
					print len(pt.dic)
					items=pt.dic.items()
					for item in items:
						print "%s == %s"%(item[0],item[1]) 				


				else:
					print "USAGE --load-test filename"
				break

			elif sys.argv[i]=="--print-keys":
				pt.read_values("/")
				pt.print_keys()
			

			elif sys.argv[i]=="--print-values":
				pt.read_values("/")
				pt.print_values()

			elif sys.argv[i]=="--print-lists":
				pt.print_lists()

			elif sys.argv[i]=="--reset":
				os.system("touch " + os.path.expanduser("~/UserFiles/.reset-gconf"))
				os.system("gnome-session-save --logout")
			else:
				print "USAGE GOES HERE"
	
	
